void get_ticks_us(u64 *ticks_return)
{
  *ticks_return = (SDL_GetTicks() * 1000);
}

void delay_us(u32 delay)
{
  SDL_Delay(delay / 1000);
}

config_struct config =
{
  // u32 pad[16];
  {
    CONFIG_BUTTON_UP, CONFIG_BUTTON_DOWN, CONFIG_BUTTON_LEFT,
    CONFIG_BUTTON_RIGHT, CONFIG_BUTTON_NONE, CONFIG_BUTTON_II,
    CONFIG_BUTTON_I, CONFIG_BUTTON_MENU, CONFIG_BUTTON_NONE,
    CONFIG_BUTTON_NONE, CONFIG_BUTTON_NONE, CONFIG_BUTTON_NONE,
    CONFIG_BUTTON_SELECT, CONFIG_BUTTON_RUN, CONFIG_BUTTON_NONE,
    CONFIG_BUTTON_NONE
  },
  0,                 // u32 show_fps;
  1,                 // u32 enable_sound;
  0,                 // u32 fast_forward;
  44100,             // u32 audio_output_frequency;
  1,                 // u32 patch_idle_loops;
  SS_SNAPSHOT_OFF,   // u32 snapshot_format;
  0,                 // u32 force_usa;

  300,               // u32 clock_speed; hurr mr pc is faster
  0,                 // u32 gp2x_ram_timings;
  100,               // u32 gp2x_gamma_percent;
  0,                 // u32 six_button_pad;
  CD_SYSTEM_TYPE_V3, // cd_system_type_enum cd_system_type;
  1,                 // u32 bz2_savestates;
  0,                 // u32 per_game_bram;
  0,                 // u32 sound_double;
  SCALE_2x,          // u32 scale_factor;
  0,                 // u32 fast_cd_access;
  0,                 // u32 fast_cd_load;
  0,                 // u32 scale_width;
  0,                 // u32 unlimit_sprites
  0,                 // u32 compatibility_mode
};

void synchronize()
{
  static u64 last_ticks = 0;
  static u64 last_last_ticks = 0;

  if(last_ticks != 0)
  {
    u64 current_ticks;

    // Point B, the beginning of the new frame.
    get_ticks_us(&current_ticks);

    s32 delay = (14000 - (current_ticks - last_ticks));

    u64 ticks_a, ticks_b;

    get_ticks_us(&ticks_a);

    if((delay > 0) && (config.fast_forward == 0))
      delay_us(delay);

    get_ticks_us(&ticks_b);
  }

  // Point A, the end of last frame.
  last_last_ticks = last_ticks;
  get_ticks_us(&last_ticks);
}

void platform_initialize()
{
  // TODO: Handle this better.

#if defined(SDL_AUDIO) && !defined(SDL_VIDEO)
  SDL_Init(SDL_INIT_AUDIO);
#endif

#if defined(SDL_AUDIO) && defined(SDL_VIDEO) && defined(SDL_EVENT)
  SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_JOYSTICK);
#endif

  freopen("CON", "wb", stdout);

  SDL_WM_SetCaption("Temper PC-Engine Emulator", "Temper");
}

void platform_quit()
{
  show_profile_stats();
  SDL_Quit();
}

