#include "common.h"

audio_struct audio;

#define _sound_copy(source_offset, length, render_type, shift)                \
{                                                                             \
  _length = (length) / 2;                                                     \
  source = audio.buffer + source_offset;                                      \
  for(i = 0; i < _length; i++)                                                \
  {                                                                           \
    current_sample = source[i] >> shift;                                      \
    if(current_sample > 32767)                                                \
      current_sample = 32767;                                                 \
    if(current_sample < -32768)                                               \
      current_sample = -32768;                                                \
    stream_base[i] = current_sample;                                          \
    source[i] = 0;                                                            \
  }                                                                           \
}                                                                             \

#define sound_copy(source_offset, length, render_type)                        \
  if(config.sound_double)                                                     \
  {                                                                           \
    _sound_copy(source_offset, length, render_type, 4);                       \
  }                                                                           \
  else                                                                        \
  {                                                                           \
    _sound_copy(source_offset, length, render_type, 5);                       \
  }                                                                           \


void audio_sync_start()
{
  audio_signal_callback();
  audio_lock();
  audio_wait_callback();
}

void audio_sync_end()
{
  audio_signal_callback();
  audio_unlock();
}

#ifdef SDL_AUDIO
  #include "SDL/SDL_audio.c"
#endif

#ifdef LINUX_AUDIO
  #include "linux/linux_audio.c"
#endif

#ifdef NULL_AUDIO

void initialize_audio()
{
  audio.output_frequency = 44100;
}

void audio_exit()
{
}

// Do not do either of these two without first locking/unlocking audio
// (see functions below)

void audio_signal_callback()
{
}

void audio_unstall_callback()
{
}

void audio_wait_callback()
{
}

void audio_reset_buffer()
{
}

void audio_lock()
{
}

void audio_unlock()
{
}

void audio_pause()
{
}

void audio_unpause()
{
}

#endif
