#ifndef AUDIO_H
#define AUDIO_H

#define AUDIO_BUFFER_SIZE (1024 * 64)

// This is how to use it: write to buffer using buffer_index with the primary
// audio source (the one you want the callback to wait on), then increment
// buffer index by the amount written. Do this all inside audio_lock and
// audio_unlock pairs.

typedef struct
{
  s32 buffer[AUDIO_BUFFER_SIZE];
  u32 buffer_base;
  u32 buffer_index;

  u32 output_frequency;
  u32 playback_buffer_size;

#ifdef SDL_AUDIO
  SDL_mutex *mutex;
  SDL_cond *cv;
#endif
} audio_struct;

extern audio_struct audio;

void initialize_audio();
void audio_sync_start();
void audio_sync_end();
void audio_exit();

void audio_signal_callback();
void audio_unstall_callback();
void audio_wait_callback();
void audio_reset_buffer();

void audio_lock();
void audio_unlock();

void audio_pause();
void audio_unpause();

#endif

