#ifndef EVENT_H
#define EVENT_H

typedef enum
{
  CONFIG_BUTTON_UP,
  CONFIG_BUTTON_DOWN,
  CONFIG_BUTTON_LEFT,
  CONFIG_BUTTON_RIGHT,
  CONFIG_BUTTON_I,
  CONFIG_BUTTON_II,
  CONFIG_BUTTON_III,
  CONFIG_BUTTON_IV,
  CONFIG_BUTTON_V,
  CONFIG_BUTTON_VI,
  CONFIG_BUTTON_RUN,
  CONFIG_BUTTON_SELECT,
  CONFIG_BUTTON_RAPID_I ,
  CONFIG_BUTTON_RAPID_II,
  CONFIG_BUTTON_RAPID_III,
  CONFIG_BUTTON_RAPID_IV,
  CONFIG_BUTTON_RAPID_V,
  CONFIG_BUTTON_RAPID_VI,
  CONFIG_BUTTON_MENU,
  CONFIG_BUTTON_SAVE_STATE,
  CONFIG_BUTTON_LOAD_STATE,
  CONFIG_BUTTON_VOLUME_DOWN,
  CONFIG_BUTTON_VOLUME_UP,
  CONFIG_BUTTON_FAST_FORWARD,
  CONFIG_BUTTON_NONE
} config_buttons_enum;


typedef enum
{
  CURSOR_UP,
  CURSOR_DOWN,
  CURSOR_LEFT,
  CURSOR_RIGHT,
  CURSOR_SELECT,
  CURSOR_BACK,
  CURSOR_EXIT,
  CURSOR_PAGE_UP,
  CURSOR_PAGE_DOWN,
  CURSOR_NONE
} gui_action_type;

#endif

// These define autorepeat values (in microseconds), tweak as necessary.

#define BUTTON_REPEAT_START    250000
#define BUTTON_REPEAT_CONTINUE 50000

typedef enum
{
  BUTTON_NOT_HELD,
  BUTTON_HELD_INITIAL,
  BUTTON_HELD_REPEAT
} button_repeat_state_type;

void initialize_event();
gui_action_type get_gui_input();
void clear_gui_actions();

#ifdef SDL_EVENT
  #include "SDL/SDL_event.h"
#endif

#ifdef GP2X_EVENT
  #include "gp2x/gp2x_event.h"
#endif

#ifdef WIZ_EVENT
  #include "wiz/wiz_event.h"
#endif

#ifdef PSP_EVENT
  #include "psp/psp_event.h"
#endif

