#ifndef PLATFORM_DEFINES_H
#define PLATFORM_DEFINES_H

// Everything here must be C preprocessor material only. That way even
// assembler files can load this.

#ifdef GP2X_BUILD

#define GP2X_OR_WIZ_BUILD

#define GP2X_MAIN
#define GP2X_VIDEO
#define GP2X_EVENT
#define LINUX_AUDIO

#define ARM_ARCH

#define COLOR_RGB

#define OGG_SUPPORT
#define OGG_TREMOR
#define BZ_SUPPORT

#define CONFIG_OPTIONS_CLOCK_SPEED
#define CONFIG_OPTIONS_RAM_TIMINGS
#define CONFIG_OPTIONS_GAMMA

#define DIR_SEPARATOR_CHAR '/'
#define DIR_SEPARATOR_CHAR_STR "/"
#define MAX_PATH 512
#define make_directory(name) mkdir(name)

#define printf(format, ...)                                                 \
  fprintf(stderr, format, ##__VA_ARGS__)                                    \


#define menu_options()                                                      \

#define MENU_CONTROLS_COLUMN_START 40
#define MENU_CONTROLS_NAME_STRING  "GP2X                 PC-Engine"

#endif


#ifdef WIZ_BUILD

#define GP2X_OR_WIZ_BUILD

#define WIZ_MAIN
#define WIZ_VIDEO
#define WIZ_EVENT
#define LINUX_AUDIO

#define ARM_ARCH
#define ARM_V5
#define OGG_SUPPORT
#define OGG_TREMOR
#define BZ_SUPPORT

#define COLOR_RGB

#define CONFIG_OPTIONS_CLOCK_SPEED

#define DIR_SEPARATOR_CHAR '/'
#define DIR_SEPARATOR_CHAR_STR "/"
#define MAX_PATH 512
#define make_directory(name) mkdir(name, 0755)

#define printf(format, ...)                                                 \
  fprintf(stderr, format, ##__VA_ARGS__)                                    \


#endif


#ifdef PC_BUILD

#define SDL_MAIN
#define SDL_VIDEO
#define SDL_EVENT
#define SDL_AUDIO

#define COLOR_RGB

#define X86_ARCH
#define OGG_SUPPORT
#define BZ_SUPPORT
#define DIR_SEPARATOR_CHAR '\\'
#define DIR_SEPARATOR_CHAR_STR "\\"
#define make_directory(name) mkdir(name)

#endif


// TODO: OGG support

#ifdef PSP_BUILD

#define PSP_MAIN
#define PSP_VIDEO
#define PSP_EVENT
#define NULL_AUDIO

#define COLOR_BGR

#define CONFIG_OPTIONS_CLOCK_SPEED

#define MIPS_ARCH
#define DIR_SEPARATOR_CHAR '/'
#define DIR_SEPARATOR_CHAR_STR "/"
#define MAX_PATH 512
#define make_directory(name) mkdir(name, 0755)

#endif

#endif

